"""
Malte Braack, Naveen Kumar Parameswaran
CAU, Kiel University, Germany

https://www.pec3.org/events/school2022/

Exercise Class 3 - Numerical Optimization
"""

import numpy as np
from exercise1 import MyFunction
from exercise2 import GradientMethod

#------------------------------------------
# Subroutines
#------------------------------------------

# Armijo step size loop
#
def armijo(f,x,d):
	[alpha,beta,sigma] = [1.,0.9,1.e-2]
	phi0 = f.value(x)
	dphi = f.grad(x) @ d
	kmax = 100
	for k in range (0,kmax):
		
		# update y and compute new function value
		y = 0.		# <-- y SHOULD BE x+alpha*d
		phi = f.value(y)
		
		# check if new value is sufficently small
		if 0 <= 1:   # <-- PUT HERE STOPPING CRITERION
			break
			
		# decrease alpha by factor beta
		alpha = 1. 	# <-- alpha SHOULD BE alpha*beta
	return alpha

#------------------------------------------

def Exercise4(x):
	GM = GradientMethod( MyFunction(), armijo)
	GM.run(x)

#------------------------------------------
# Main programme
#------------------------------------------

print ("\nExercise 4:")
x0 =  [0.1 , 1.]
Exercise4(x0)
